extends MeshInstance3D

@onready var label = get_node("/root/Node3D/Label")

# Called when the node enters the scene tree for the first time.
func _ready():
	pass # Replace with function body.


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	# Get mesh vertex and vertex index data...
	var mesh = self.get_mesh()
	var mesh_array = mesh.surface_get_arrays(0)
	# Vertices which make up the mesh
	var vertex_array = mesh_array[Mesh.ARRAY_VERTEX]
	# Order in which the vertices make up the mesh triangles
	var index_array = mesh_array[Mesh.ARRAY_INDEX]
	
	# Iterate through each vertex_index in the index_array
	for index in range (0, index_array.size()):
		var vertex_index = index_array[index]
		# Check if the current vertex_index exists in the vertex_array
		if(vertex_index >= vertex_array.size()):
			label.set_text("Vertex index out of bounds! Index " + str(vertex_index) )
